###############################################################################
# Admin.pl                                                                    #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub Admin
{if (!hasPermission('admin'))
{fatal_error('nopermission');
}my $texts = (hasPermission('admin_banlist')?"<tr><td><a href=\"$cgi&action=viewbanlist\">$text{admin_banlist}</a></td></tr>":"");
$texts .= (hasPermission('admin_traffic')?"<tr><td><a href=\"$cgi&action=viewtraffic\">$text{admin_traffic}</a></td></tr>":"");
$texts .= (hasPermission('admin_news')?"<tr><td><a href=\"$cgi&action=viewnews\">$text{admin_news}</a></td></tr>":"");
$texts .= (hasPermission('admin_settings')?"<tr><td><a href=\"$cgi&action=modifysettings\">$text{admin_settings}</a></td></tr>":"");
$texts .= (hasPermission('admin_permissions')?"<tr><td><a href=\"$cgi&action=modifypermissions\">$text{admin_permissions}</a></td></tr>":"");
$texts .= (hasPermission('admin_smileys')?"<tr><td><a href=\"$cgi&action=viewsmileys\">$text{admin_smileys}</a></td></tr>":"");
$texts .= (hasPermission('admin_aliases0')?"<tr><td><a href=\"$cgi&action=viewaliases&list=0\">$text{admin_commandaliases}</a></td></tr>":"");
$texts .= (hasPermission('admin_aliases1')?"<tr><td><a href=\"$cgi&action=viewaliases&list=1\">$text{admin_coloraliases}</a></td></tr>":"");
$texts .= (hasPermission('admin_messages')?"<tr><td><a href=\"$cgi&action=viewmessages\">$text{admin_messages}</a></td></tr>":"");
$texts .= (hasPermission('admin_texts')?"<tr><td><a href=\"$cgi&action=viewtexts\">$text{admin_texts}</a></td></tr>":"");
$texts .= (hasPermission('admin_list0')?"<tr><td><a href=\"$cgi&action=modifylist&list=0\">$text{admin_groupnames}</a></td></tr>":"");
$texts .= (hasPermission('admin_list1')?"<tr><td><a href=\"$cgi&action=modifylist&list=1\">$text{admin_grouptags}</a></td></tr>":"");
$texts .= (hasPermission('admin_list2')?"<tr><td><a href=\"$cgi&action=modifylist&list=2\">$text{admin_monthsnames}</a></td></tr>":"");
if ($maintenance == 0)
{$texts .= (hasPermission('admin_maintenance')?"<tr><td><a href=\"$cgi&action=domaintenance\">$text{admin_maintenance}</a></td></tr>":"");
}else
{$texts .= (hasPermission('admin_maintenance')?"<tr><td><a href=\"$cgi&action=endmaintenance\">$text{admin_maintenance_end}</a></td></tr>":"");
}my $rows =<<"EOT";
<tr><th>$text{admin_title}</th></tr>
<tr id="table2"><td><table width=100%>
$texts
</table></td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{admin_title},
'{ROWS}' => $rows,
'{COMMENT}' => $text{admin_comment}));
exitprog();
}sub ViewTraffic
{if (!hasPermission('admin_traffic'))
{fatal_error('nopermission');
}my $rows =<<"EOT";
<tr>
<th>$text{trafficstats_date}</th>
<th>$text{trafficstats_traffic}</th>
</tr>
EOT
open(FILE,"$vardir/traffic.txt");
readlock(FILE);
my @entries=<FILE>;
unlock(FILE);
close(FILE);
foreach $entry (@entries)
{$entry =~ s/[\n\r]//g;
my($date,$count) = split(/\|/,$entry);
my $mass="Bytes";
if ($count>1024)
{$count = sprintf("%.2f",$count/1024);
$mass="kB";
if ($count>1024)
{$count = sprintf("%.2f",$count/1024);
$mass="MB";
}}$rows .=<<"EOT";
<tr id="table2">
<td>$date</td>
<td>$count $mass</td>
</tr>
EOT
}$rows .=<<"EOT";
<tr id="table2">
<td colspan=2 align=center><a href="$cgi&action=cleartraffic">$text{trafficstats_clear}</a></td>
</tr>
EOT
my $active= ($enable_traffic_stat == 0?'deactivated':'activated');
printheader("popup","",('{TITLE}' => $text{trafficstats_title},
'{ROWS}' => $rows,
'{COMMENT}' => sprintf($text{trafficstats_comment},"<b>$text{$active}</b>")));
exitprog();
}sub ClearTraffic
{if (!hasPermission('admin_traffic'))
{fatal_error('nopermission');
}open(FILE,">$vardir/traffic.txt");
lock(FILE);
unlock(FILE);
close(FILE);
output("Location: $cgi&action=viewtraffic\n\n");
}sub ViewNews
{if (!hasPermission('admin_news'))
{fatal_error('nopermission');
}my $rows =<<"EOT";
<tr>
<th colspan=2>$text{viewnews_title}</th>
</tr>
EOT
open(FILE,"$vardir/news.txt");
readlock(FILE);
my @entries=<FILE>;
unlock(FILE);
close(FILE);
for (my $i=0;$i<@entries;$i++)
{$entries[$i] =~ s/[\n\r]//g;
$rows .=<<"EOT";
<tr id="table2">
<td width=100%>$entries[$i]</td>
<td nowrap>
<a href="$cgi&action=modifynews&num=$i">$text{viewnews_entry_modify}</a><br>
<a href="$cgi&action=deletenews&num=$i">$text{viewnews_entry_delete}</a>
</td>
</tr>
EOT
}$rows .=<<"EOT";
<tr id="table2">
<td colspan=2 align=center><a href="$cgi&action=modifynews&num=-1">$text{viewnews_createnew}</a></td>
</tr>
EOT
printheader("popup","",('{TITLE}' => $text{viewnews_title},
'{ROWS}' => $rows,
'{COMMENT}' => $text{viewnews_comment}));
exitprog();
}sub ModifyNews
{if (!hasPermission('admin_news'))
{fatal_error('nopermission');
}my $text="";
if ($INFO{num} >= 0)
{open(FILE,"$vardir/news.txt");
readlock(FILE);
my @entries=<FILE>;
unlock(FILE);
close(FILE);
$text=$entries[$INFO{num}];
$text =~ s/[\n\r]//g;
}my $rows =<<"EOT";
<tr><th>$text{modifynews_title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi&action=modifynews2">
<input type=hidden name="num" value="$INFO{num}">
<tr>
<td nowrap valign="top"><b>$text{modifynews_text}:</b></td>
<td width=100%><textarea name="text" cols=35 rows=6 style="width:100%">$text</textarea></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit value="$text{modifynews_submit}">
</td>
</tr>
</form>
</table></td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{modifynews_title},
'{ROWS}' => $rows,
'{COMMENT}' => $text{modifynews_comment}));
exitprog();
}sub ModifyNews2
{if (!hasPermission('admin_news'))
{fatal_error('nopermission');
}$FORM{text} =~ s/\r//g;
$FORM{text} =~ s/\n/<br>/g;
if ($FORM{num}<0)
{open(FILE,">>$vardir/news.txt");
lock(FILE);
print FILE "$FORM{text}\n";
unlock(FILE);
close(FILE);
}else
{open(FILE,"+<$vardir/news.txt");
lock(FILE);
my @entries=<FILE>;
seek(FILE,0,0);
for (my $i=0;$i<@entries;$i++)
{if ($i==$FORM{num})
{print FILE "$FORM{text}\n";
}else
{print FILE $entries[$i];
}}truncate(FILE, tell(FILE));
unlock(FILE);
close(FILE);
}output("Location: $cgi&action=viewnews\n\n");
exitprog();
}sub DeleteNews
{if (!hasPermission('admin_news'))
{fatal_error('nopermission');
}open(FILE,"+<$vardir/news.txt");
lock(FILE);
my @entries=<FILE>;
seek(FILE,0,0);
for (my $i=0;$i<@entries;$i++)
{if ($i!=$INFO{num})
{print FILE $entries[$i];
}}truncate(FILE, tell(FILE));
unlock(FILE);
close(FILE);
output("Location: $cgi&action=viewnews\n\n");
exitprog();
}1;
