###############################################################################
# BanList.pl                                                                  #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub ModifyBanList
{if (!hasPermission('admin_banlist'))
{fatal_error('nopermission');
}my $delete="";
my $title=$text{createbanlistentry_title};
if ($INFO{time} != 0)
{$delete="<input type=submit onClick=\"form.action.value='deletebanlist'\" value=\"$text{deletebanlistentry_submit}\">";
$title=$text{modifybanlistentry_title};
}printheader("popup","{ROWS}",('{TITLE}' => $title,
'{COMMENT}' => $text{modifybanlistentry_comment}));
output(<<"EOT");
<tr><th>$title</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi">
<input type=hidden name=action value="modifybanlist2">
<input type=hidden name=time value="$INFO{time}">
<tr>
<td><b>$text{banlist_domain}:</b></td>
<td><input type=text name=domain value="$INFO{domain}" size=20></td>
</tr>
<tr>
<td><b>$text{banlist_ip}:</b></td>
<td><input type=text name=ip value="$INFO{ip}" size=20></td>
</tr>
<tr>
<td><b>$text{banlist_clientip}:<b></td>
<td><input type=text name=forwardedfor value="$INFO{forwardedfor}" size=20></td>
</tr>
<tr>
<td><b>$text{banlist_commenttext}:<b></td>
<td><input type=text name=comment value="$INFO{comment}" size=20></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit onClick="form.action.value='modifybanlist2'" value="$text{modifybanlistentry_submit}">
$delete
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $title,
'{COMMENT}' => $text{modifybanlistentry_comment}));
exitprog();
}sub ModifyBanList2
{if (!hasPermission('admin_banlist'))
{fatal_error('nopermission');
}$FORM{domain} =~ s/[^a-zA-Z0-9\.\-\_]//g;
$FORM{ip} =~ s/[^0-9\.]//g;
$FORM{forwardedfor} =~ s/[^0-9\.]//g;
ToHTML($FORM{comment});
if ($FORM{domain} eq "" && $FORM{ip} eq "" && $FORM{forwardedfor} eq "")
{fatal_error('ban_nothingtodo');
}open(FILE, "+<$vardir/banlist.txt");
lock(FILE);
my @entries = <FILE>;
seek(FILE,0,0);
print FILE "$FORM{domain}|$FORM{ip}|$FORM{forwardedfor}|" . time() . "|$FORM{comment}\n";
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @entrydata = split(/\|/, $curentry);
if($entrydata[3]!=$FORM{time})
{print FILE "$curentry\n";
}}truncate(FILE, tell(FILE));
unlock(FILE);
close(FILE);
output("Location: $cgi&action=viewbanlist\n\n");
}sub ViewBanList
{if (!hasPermission('admin_banlist'))
{fatal_error('nopermission');
}open(FILE,"$vardir/banlist.txt");
readlock(FILE);
my @entries=<FILE>;
unlock(FILE);
close(FILE);
printheader("popup","{ROWS}",('{TITLE}' => $text{banlist_title},
'{COMMENT}' => $text{banlist_comment}));
output(<<"EOT");
<tr>
<th><b>$text{banlist_domain}</b></th>
<th><b>$text{banlist_ip}</b></th>
<th><b>$text{banlist_clientip}</b></th>
<th><b>$text{banlist_time}</b></th>
<th><b>$text{banlist_commenttext}</b></th>
<th>&nbsp;</th>
</tr>
EOT
foreach my $entry (@entries)
{my($domain,$ip,$forwardedfor,$time,$comment) = split(/\|/,$entry);
$date = toDate($time);
output(<<"EOT");
<tr id="table2">
<td>$domain&nbsp;</td>
<td>$ip&nbsp;</td>
<td>$forwardedfor&nbsp;</td>
<td id="smalltext">$date&nbsp;</td>
<td>$comment&nbsp;</td>
<td><a href="$cgi&action=modifybanlist&domain=$domain&ip=$ip&forwardedfor=$forwardedfor&time=$time&comment=$comment">$text{banlist_entry_modify}</a></td>
</tr>
EOT
}output(<<"EOT");
<tr id="table2">
<td colspan=6 align=center><a href="$cgi&action=modifybanlist">$text{banlist_createnewentry}</a></td>
</tr>
</table>
</td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{banlist_title},
'{COMMENT}' => $text{banlist_comment}));
exitprog();
}sub DeleteBanList
{if (!hasPermission('admin_banlist'))
{fatal_error('nopermission');
}open(FILE, "+<$vardir/banlist.txt");
lock(FILE);
my @entries = <FILE>;
seek(FILE,0,0);
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @entrydata = split(/\|/, $curentry);
if($entrydata[3]!=$FORM{time})
{print FILE "$curentry\n";
}}truncate(FILE, tell(FILE));
unlock(FILE);
close(FILE);
output("Location: $cgi&action=viewbanlist\n\n");
}1;
