###############################################################################
# EditSettings.pl                                                             #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
my $fields=
'chatname|30
defaultcolor|10
defaultroom|30
enable_news|0
enable_traffic_stat|0
enable_smileys|0
allow_guestlogin|0
use_usernames|0
use_server_auth|0
pull_mode_only|0
webmaster_email|30
mailprog|60
cookie_name|30
alive_test_rate|4
log_clean_rate|5
log_length|5
time_distance|2
max_login_time|3';
sub ModifySettings
{if (!hasPermission('admin_settings'))
{fatal_error('nopermission');
}require "$language.descr";
my $output=<<"EOT";
<tr><th>$text{settings_title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi&action=modifysettings2">
EOT
foreach my $entry (split(/\n/,$fields))
{my($name,$length)=split(/\|/,$entry);
my $value;
eval("\$value=\$$name;");
my $description = getDescription('settings_' . $name);
if ($length>0)
{$output .=<<"EOT";
<tr>
<td nowrap>$text{'settings_' . $name}:$description</td>
<td width="100%"><input type=text name=$name value="$value" size=20 maxlength="$length" style="width:100%"></td>
</tr>
EOT
}else
{my $checked = ($value==0?"":" checked");
$output .=<<"EOT";
<tr>
<td nowrap>$text{'settings_' . $name}:$description</td>
<td width="100%"><input type=checkbox name=$name value="1" $checked></td>
</tr>
EOT
}}$output .= <<"EOT";
<tr>
<td colspan=2 align=center><input type=submit value="$text{settings_submit}"></td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{settings_title},
'{ROWS}' => $output,
'{COMMENT}' => $text{settings_comment}));
exitprog();
}sub ModifySettings2
{if (!hasPermission('admin_settings'))
{fatal_error('nopermission');
}fatal_error('unknowncolor',$FORM{defaultcolor}) if (makecolor($FORM{defaultcolor}) eq "");
$FORM{defaultcolor}=makecolor($FORM{defaultcolor});
fatal_error('illegalemail') if($FORM{webmaster_email} !~ /^[0-9A-Za-z@\._\-]*$/);
my %roominfo=getroominfo($FORM{defaultroom});
fatal_error('unknownroom',$FORM{defaultroom}) if (!defined($roominfo{name}));
fatal_error('illegaldefaultroom') if ($roominfo{closed}!=0 || $roominfo{permanent}==0);
fatal_error('mailprognotfound') if ($FORM{mailprog} ne "" && !-e($FORM{mailprog}));
$FORM{cookie_name} =~ s/[^a-zA-Z0-9]/_/g;
foreach my $entry (split(/\n/,$fields))
{my($name,$length)=split(/\|/,$entry);
eval("\$$name=\$FORM{$name};");
}writeSettingsFile();
print "Location: $cgi&action=admin\n\n";
exitprog();
}1;
