###############################################################################
# Send.pl                                                                     #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub Send
{($user{name}, $user{nick}, $user{room}, $user{ipcid}) = getonlineinfo($user{name});
if ($user{name} eq "")
{out();
}my $text = "";
my %params = Parse($FORM{text});
if ($params{command} eq "error")
{out();
}elsif ($params{command} eq "")
{if (time() < $user{gagtime})
{OutputCommand(ErrorText('gagged'),$user{name});
out();
}my $tonick="";
if ($user{away} != 0)
{$user{away}=0;
writememberinfo(%user);
$text=CommandToText(command => 'away',
name => $user{name},
nick => $user{nick},
away => 0);
OutputCommand($text,$user{name},$user{room});
}my @words = split(/\s/,$params{text});
while ($words[@words-1] =~ /^\@[^\@]+$/)
{unshift(@words,pop(@words));
}while ($words[0] =~ /^[^\:]+:$/ || $words[0] =~ /^\@[^\@]+$/)
{CheckName($words[0]);
my @list = completeName($words[0],$user{room});
if ($list[0] eq "")
{OutputCommand(ErrorText('notinroom',$words[0]),$user{name});
last;
}elsif ($list[2] ne "")
{OutputCommand(ErrorText('ambiguousname',$words[0]),$user{name});
last;
}else
{$tonick .= "$list[1] ";
shift(@words);
$params{text}=join(" ",@words);
}}$tonick =~ s/\s$//g;
if ($params{text} ne "")
{$text=CommandToText(command => 'text',
name => $user{name},
nick => $user{nick},
color => $user{color},
tonick => $tonick,
text => ToHTML($params{text}));
OutputCommand($text,$user{name},$user{room});
}}elsif ($params{command} eq "/msg")
{if (time() < $user{gagtime})
{OutputCommand(ErrorText('gagged'),$user{name});
out();
}if ($params{user} eq "")
{OutputCommand(ErrorText('msg_namenotgiven'),$user{name});
}elsif ($params{user} eq "$user{name}|$user{nick}")
{OutputCommand(ErrorText('msgtooneself'),$user{name});
}elsif ($params{text} ne "")
{my($toname,$tonick) = split(/\|/,$params{user});
$text=CommandToText(command => 'msg',
nick => $user{nick},
color => $user{color},
from => $user{name},
to => $toname,
tonick => $tonick,
text => ToHTML($params{text}));
OutputCommand($text,$user{name});
OutputCommand($text,$toname);
}}elsif ($params{command} eq "/me")
{if (time() < $user{gagtime})
{OutputCommand(ErrorText('gagged'),$user{name});
out();
}if ($params{text} ne "")
{$text=CommandToText(command => 'me',
name => $user{name},
nick => $user{nick},
color => $user{color},
text => ToHTML($params{text}));
OutputCommand($text,$user{name},$user{room});
}}elsif ($params{command} eq "/away")
{if (time() < $user{gagtime})
{OutputCommand(ErrorText('gagged'),$user{name});
out();
}$user{away}=1;
writememberinfo(%user);
$text=CommandToText(command => 'away',
name => $user{name},
nick => $user{nick},
text => ToHTML($params{text}),
away => 1);
OutputCommand($text,$user{name},$user{room});
}elsif ($params{command} eq "/color")
{if ($params{color} eq "")
{OutputCommand(InfoText('currentcolor!',"<font color=\"$user{color}\">$user{color}</font>"),$user{name});
}else
{$user{color}=$params{color};
writememberinfo(%user);
$text=CommandToText(command => 'color',
nick => $user{nick},
color => $user{color});
OutputCommand($text,$user{name});
}}elsif ($params{command} eq "/nick")
{CheckName($params{nick});
if ($params{nick} eq "")
{OutputCommand(InfoText('nickname',$user{nick}),$user{name});
}elsif ($params{nick} eq $user{nick})
{OutputCommand(ErrorText('samenickname'),$user{name});
}else
{my $oldnick = $user{nick};
$user{nick} = $params{nick};
if (addToMemberList($user{name},$user{nick}) == 1)
{writememberinfo(%user);
writeonlineinfo(0,$user{name},$user{nick},$user{room},$user{ipcid},$INFO{id});
$text=CommandToText(command => 'nick',
name => $user{name},
text => getMessage('info_nickchanged',$oldnick,$user{nick}));
OutputCommand($text,$user{name},$user{room});
}else
{OutputCommand(ErrorText('nicknameexists',$user{nick}),$user{name});
}}}elsif ($params{command} eq "/quit")
{$text=CommandToText(command => 'quit',
name => $user{name},
text => getMessage('out_chat',$user{nick},$chatname),
room => $user{room},
id => $INFO{id});
OutputCommand($text);
}elsif ($params{command} eq "/room")
{if ($params{room} eq "")
{OutputCommand(InfoText('room',$user{room}),$user{name});
}elsif ($params{room} ne $user{room})
{my $oldroom = $user{room};
$user{room} = $params{room};
writeonlineinfo(0,$user{name},$user{nick},$user{room},$user{ipcid},$INFO{id});
writememberinfo(%user);
TestRoomTemporary($oldroom);
$text=CommandToText(command => 'room',
name => $user{name},
roomout => $oldroom,
textout => getMessage('out_room',$user{nick},"$oldroom"),
roomin => $user{room},
textin => getMessage('in_room',$user{nick},"$user{room}"));
OutputCommand($text);
}}elsif ($params{command} eq "/ignore")
{if ($params{user} eq "")
{my $list = "";
foreach my $entry (split(/\s/,$user{ignore}))
{my %userinfo = getmemberinfo($entry);
if ($userinfo{name} ne "")
{$list .= "$userinfo{nick}, ";
}}if ($list eq "")
{$text=InfoText('ignorenoone');
} else {
$list =~ s/, $//;
$text=InfoText('ignore',$list);
}OutputCommand($text,$user{name});
}else
{my($name,$nick) = split(/\|/,$params{user});
if ($name eq $user{name})
{OutputCommand(ErrorText('ignoreoneself'),$user{name});
out();
}my @list = split(/\s/,$user{ignore});
foreach my $entry (@list)
{if ($entry eq $name)
{OutputCommand(ErrorText('alreadyignored',$nick),$user{name});
out();
}}push(@list,$name);
$user{ignore}=join(" ",@list);
writememberinfo(%user);
OutputCommand(InfoText('ignored',$user{nick}),$name);
$text=CommandToText(command => 'ignore',
name => $name,
nick => $nick);
OutputCommand($text,$user{name});
}}elsif ($params{command} eq "/unignore")
{if ($params{user} eq "")
{OutputCommand(ErrorText('unignore_namenotgiven'),$user{name});
}else
{my($name,$nick) = split(/\|/,$params{user});
my @list = split(/\s/,$user{ignore});
for (my $i=0;$i<@list;$i++)
{if ($list[$i] eq $name)
{splice(@list,$i,1);
$user{ignore}=join(" ",@list);
writememberinfo(%user);
OutputCommand(InfoText('notignored',$user{nick}),$name);
$text=CommandToText(command => 'unignore',
name => $name,
nick => $nick);
OutputCommand($text,$user{name});
out();
}}OutputCommand(ErrorText('notignored',$nick),$user{name});
}}elsif ($params{command} eq "/smileys" && $enable_smileys != 0)
{if ($params{activate} eq "")
{OutputCommand(InfoText($user{smileys}==1?'smileyson':'smileysoff'),$user{name});
}elsif ($params{activate} ne $user{smileys})
{$user{smileys}=$params{activate};
writememberinfo(%user);
$text=CommandToText(command => 'smileys',
nick => $user{nick},
smileys => $user{smileys});
OutputCommand($text,$user{name});
}}elsif ($params{command} eq "/invite")
{my %room=getroominfo($user{room});
if ($room{closed}==0)
{OutputCommand(ErrorText('invite_publicroom'),$user{name});
out();
}if (!hasPermission('invite') && $user{name} ne $room{owner})
{OutputCommand(ErrorText('invite_nopermission'),$user{name});
out();
}if ($params{user} eq "")
{my $list = "";
foreach my $entry (split(/\s/,$room{invited}))
{my %userinfo = getmemberinfo($entry);
if ($userinfo{name} ne "")
{$list .= "$userinfo{nick}, ";
}}if ($list eq "")
{$text=InfoText('invitenoone');
} else {
$list =~ s/, $//;
$text=InfoText('invite',$list);
}OutputCommand($text,$user{name});
}else
{my($name,$nick) = split(/\|/,$params{user});
my @list = split(/\s/,$room{invited});
foreach my $entry (@list)
{if ($entry eq $name)
{OutputCommand(ErrorText('alreadyinvited',$nick),$user{name});
out();
}}push(@list,$name);
$room{invited}=join(" ",@list);
writeroominfo(%room);
OutputCommand(InfoText('invitesuccess',$nick),$user{name});
$text=CommandToText(command => 'invite',
room => $room{name},
invite => 1);
OutputCommand($text,$name);
}}elsif ($params{command} eq "/uninvite")
{my %room=getroominfo($user{room});
if ($room{closed}==0)
{OutputCommand(ErrorText('invite_publicroom'),$user{name});
out();
}if (!hasPermission('invite') && $user{name} ne $room{owner})
{OutputCommand(ErrorText('invite_nopermission'),$user{name});
out();
}if ($params{user} eq "")
{OutputCommand(ErrorText('uninvite_namenotgiven'),$user{name});
}else
{my($name,$nick) = split(/\|/,$params{user});
my @list = split(/\s/,$room{invited});
for (my $i=0;$i<@list;$i++)
{if ($list[$i] eq $name)
{splice(@list,$i,1);
$room{invited}=join(" ",@list);
writeroominfo(%room);
OutputCommand(InfoText('uninvitesuccess',$nick),$user{name});
$text=CommandToText(command => 'invite',
room => $room{name},
invite => 0);
OutputCommand($text,$name);
out();
}}OutputCommand(ErrorText('notinvited',$nick),$user{name});
}}elsif ($params{command} eq "/alive")
{$text=CommandToText(command => 'alive');
OutputCommand($text,$user{name});
}elsif ($params{command} eq "/img" && hasPermission('img'))
{if ($params{url} ne "")
{if ($params{url} !~ /^\w*\:\/\//)
{$params{url} = "http://$params{url}";
}my($name,$nick) = split(/\|/,$params{user});
$text=CommandToText(command => 'img',
nick => $user{nick},
tonick => $nick,
url => $params{url});
if ($params{user} eq "")
{OutputCommand($text,$user{name},$user{room});
}else
{if ($name eq $user{name})
{OutputCommand(ErrorText('msgtooneself'),$user{name});
}else
{OutputCommand($text,$user{name});
OutputCommand($text,$name);
}}}}elsif ($params{command} eq "/push" && hasPermission('push'))
{if ($params{user} eq "")
{OutputCommand(ErrorText('push_namenotgiven'),$user{name});
out();
}my($name,$nick) = split(/\|/,$params{user});
my %userinfo=getmemberinfo($name);
if ($userinfo{group}>0)
{OutputCommand(ErrorText('push_admin',$nick),$user{name});
out();
}if ($params{room} eq "")
{OutputCommand(ErrorText('push_roomnotgiven'),$user{name});
out();
}if ($params{room} eq $userinfo{room})
{OutputCommand(ErrorText('push_alreadythere'),$user{name});
out();
}OutputCommand(InfoText('pushed',$user{nick},$nick,$params{room}),$user{name},$userinfo{room});
($userinfo{name}, $userinfo{nick}, $userinfo{room}, $userinfo{ipcid}, $userinfo{id}) = getonlineinfo($userinfo{name});
my $oldroom = $userinfo{room};
$userinfo{room} = $params{room};
writeonlineinfo(0,$userinfo{name},$userinfo{nick},$userinfo{room},$userinfo{ipcid},$userinfo{id});
writememberinfo(%userinfo);
TestRoomTemporary($oldroom);
$text=CommandToText(command => 'room',
name => $userinfo{name},
roomout => $oldroom,
textout => getMessage('out_room',$userinfo{nick},"$oldroom"),
roomin => $userinfo{room},
textin => getMessage('in_room',$userinfo{nick},"$userinfo{room}"));
OutputCommand($text);
}elsif ($params{command} eq "/kick" && hasPermission('kick'))
{if ($params{user} eq "")
{OutputCommand(ErrorText('kick_namenotgiven'),$user{name});
out();
}my($name,$nick) = split(/\|/,$params{user});
my %userinfo=getmemberinfo($name);
if ($userinfo{group}>0)
{OutputCommand(ErrorText('kick_admin',$nick),$user{name});
out();
}OutputCommand(InfoText('kicked',$user{nick},$nick),$user{name},$userinfo{room});
$text=CommandToText(command => 'quit',
name => $userinfo{name},
text => getMessage('out_chat',$userinfo{nick},"$chatname"),
room => $userinfo{room});
OutputCommand($text);
}elsif ($params{command} eq "/gag" && hasPermission('gag'))
{if ($params{user} eq "")
{OutputCommand(ErrorText('gag_namenotgiven'),$user{name});
out();
}my($name,$nick) = split(/\|/,$params{user});
my %userinfo=getmemberinfo($name);
if ($userinfo{group}>0)
{OutputCommand(ErrorText('gag_admin',$nick),$user{name});
out();
}my $gagtime=$params{time}+0;
if ($params{time} eq "")
{$gagtime = 5;
}if ($gagtime > 0)
{OutputCommand(InfoText('gagged',$user{nick},$nick,$gagtime),$user{name},$userinfo{room});
}elsif (time()<$userinfo{gagtime})
{OutputCommand(InfoText('ungagged',$user{nick},$nick),$user{name},$userinfo{room});
}$userinfo{gagtime} = time()+$gagtime*60;
writememberinfo(%userinfo);
}elsif ($params{command} eq "/broadcast" && hasPermission('broadcast'))
{if ($params{text} ne "")
{$text=CommandToText(command => 'broadcast',
nick => $user{nick},
color => $user{color},
text => ToHTML($params{text}));
OutputCommand($text);
}}else
{OutputCommand(ErrorText('unknowncommand',$params{command}),$user{name});
}out();
}sub Parse
{my($string) = @_;
$string =~ s/^\s+//g;
$string =~ s/\s+$//g;
$string =~ s/(\s)\s+/$1/g;
my @params = split(/\s/,$string);
my %ret=(command => $params[0]);
lowercase($ret{command});
if ($ret{command} =~ /^\/[^\s]+$/)
{if (exists($alias{$ret{command}}))
{splice(@params,0,1,split(/\s/,$alias{$ret{command}}));
}$ret{command}=$params[0];
lowercase($ret{command});
shift(@params);
if (exists($format{$ret{command}}))
{my @fields = split(/\|/,$format{$ret{command}});
foreach my $field (@fields)
{my($name,$type)=split(/=/,$field);
if ($type eq "word")
{$ret{$name} = $params[0];
}elsif ($type eq "color" && $params[0] ne "")
{$ret{$name} = makecolor($params[0]);
if ($ret{$name} eq "")
{OutputCommand(ErrorText('unknowncolor',$params[0]),$user{name});
$ret{command}="error";
return %ret;
}}elsif ($type eq "on/off" && $params[0] ne "")
{lowercase($params[0]);
if ($params[0] eq "on" || $params[0] eq "yes")
{$ret{$name} = 1;
}elsif ($params[0] eq "off" || $params[0] eq "no")
{$ret{$name} = 0;
}else
{OutputCommand(ErrorText('onoff'),$user{name});
$ret{command}="error";
return %ret;
}}elsif (($type eq "name" || $type eq "member") && $params[0] ne "")
{my @list = completeName($params[0]);
if ($list[0] eq "" && $type eq "member")
{@list = completeMember($params[0]);
}if ($list[0] eq "")
{OutputCommand(ErrorText(($type eq "name"?'notonline':'notfound'),$params[0]),$user{name});
$ret{command}="error";
return %ret;
}elsif ($list[2] ne "")
{OutputCommand(ErrorText('ambiguousname',$params[0]),$user{name});
$ret{command}="error";
return %ret;
}else
{$ret{$name} = "$list[0]|$list[1]";
}}elsif ($type eq "room" && $params[0] ne "")
{my %room=getroominfo($params[0]);
if ($room{name} eq "" || RoomPermitted(%room)==0)
{OutputCommand(ErrorText('unknownroom',$params[0]),$user{name});
$ret{command}="error";
return %ret;
}else
{$ret{$name} = $room{name};
}}shift(@params);
}}}else
{$ret{command} = "";
}$ret{text} = join(" ",@params);
return %ret;
}sub out()
{print "Pragma: no-cache\n";
print "Expires: now\n";
if ($user{pull}==0)
{print "Location: $htmlurl/dummy.html\n\n";
}else
{print "Location: $cgi&action=refresh\n\n";
}exitprog();
}1;
