#!/usr/bin/perl
###############################################################################
# chat.pl                                                                     #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
use CGI::Carp qw(fatalsToBrowser);
require "Settings.dat";
require "Directories.dat";
require "$language.lng";
require "$sourcedir/Definitions.pl";
require "$sourcedir/Subs.pl";
&readform;
$cgi = "$cgiurl/chat.pl?id=$INFO{id}";
$queue = 0;
$caller_ip = $ENV{REMOTE_ADDR};
$caller_forwardedfor = $ENV{HTTP_X_FORWARDED_FOR};
$caller_host = gethostbyaddr(pack("C4",split(/\./,$caller_ip)),$PF_INET);
open(FILE,"$vardir/banlist.txt");
readlock(FILE);
@banned = <FILE>;
unlock(FILE);
close(FILE);
foreach my $entry (@banned)
{my($domain,$ip,$forwardedfor,$time,$comment) = split(/\|/,$entry);
if ($domain ne "" || $ip ne "" || $forwardedfor ne "")
{if (($domain eq "" || $caller_host =~ /\Q$domain\E$/) &&
($ip eq "" || $caller_ip =~ /\Q$ip\E/) &&
($forwardedfor eq "" || $caller_forwardedfor =~ /\Q$forwardedfor\E/))
{ToHTML($webmaster_email);
fatal_error('ipbanned!',"<a href=\"mailto:$webmaster_email\">$webmaster_email</a>");
}}}foreach my $cookie (split(/; /,$ENV{HTTP_COOKIE}))
{my($name,$value)=split(/=/,$cookie);
$COOKIE{$name}=$value;
}if ($use_server_auth!=0)
{$use_usernames=1;
$enable_guestlogin=0;
}if ($action ne "frames" && $action ne "receive" && $action ne "loginframe" && $action ne "reminder" && $action ne "reminder2" && $action ne "removecookie" && $action ne "register" && ($action ne "register2" || $FORM{modify} == 1) && $action ne "")
{open(FILE,"$vardir/online.txt");
readlock(FILE);
my @entries=<FILE>;
unlock(FILE);
close(FILE);
my $username="";
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/,$curentry);
if ($userdata[4] eq $INFO{id})
{$username=$userdata[0];
}}if($username eq "" && $action ne "allusers")
{if ($action ne "refresh")
{fatal_error('nologinrecord');
}else
{printheader("script","",('{SCRIPT}' => "cgi=\"$cgi\";doLogin()"));
exitprog();
}}%user = getmemberinfo($username);
if(!defined($user{name}) && $action ne "allusers")
{if ($action ne "refresh")
{fatal_error('unknownusername',$username);
}else
{printheader("refresh","",('{SCRIPT}' => "doLogin()"));
exitprog();
}}}if ($maintenance != 0 && !hasPermission('admin_maintenance')) { require "$sourcedir/Maintenance.pl"; &Maintenance; }
if ($action eq "frames") { require "$sourcedir/Login.pl"; &Frames; }
if ($action eq "send") { require "$sourcedir/Send.pl"; &Send; }
if ($action eq "receive") { require "$sourcedir/Receive.pl"; &Receive; }
if ($action eq "userlist") { require "$sourcedir/UserList.pl"; &UserList;}
if ($action eq "allusers") { require "$sourcedir/UserList.pl"; &AllUsers;}
if ($action eq "searchuser") { require "$sourcedir/UserList.pl"; &SearchUser;}
if ($action eq "searchuser2") { require "$sourcedir/UserList.pl"; &SearchUser2;}
if ($action eq "inputframe") { require "$sourcedir/InputFrame.pl"; &InputFrame;}
if ($action eq "optionsframe") { require "$sourcedir/InputFrame.pl"; &OptionsFrame;}
if ($action eq "roomlist") { require "$sourcedir/RoomList.pl"; &RoomList;}
if ($action eq "viewrooms") { require "$sourcedir/RoomList.pl"; &ViewRooms;}
if ($action eq "modifyroom") { require "$sourcedir/RoomList.pl"; &ModifyRoom;}
if ($action eq "modifyroom2") { require "$sourcedir/RoomList.pl"; &ModifyRoom2;}
if ($action eq "deleteroom") { require "$sourcedir/RoomList.pl"; &DeleteRoom;}
if ($action eq "register") { require "$sourcedir/Profile.pl"; &Register;}
if ($action eq "register2") { require "$sourcedir/Profile.pl"; &Register2;}
if ($action eq "viewprofile") { require "$sourcedir/Profile.pl"; &ViewProfile;}
if ($action eq "modifyprofile") { require "$sourcedir/Profile.pl"; &ModifyProfile;}
if ($action eq "deleteuser") { require "$sourcedir/Profile.pl"; &DeleteUser;}
if ($action eq "traceroute") { require "$sourcedir/Profile.pl"; &TraceRoute;}
if ($action eq "viewbanlist") { require "$sourcedir/BanList.pl"; &ViewBanList;}
if ($action eq "modifybanlist") { require "$sourcedir/BanList.pl"; &ModifyBanList;}
if ($action eq "modifybanlist2") { require "$sourcedir/BanList.pl"; &ModifyBanList2;}
if ($action eq "deletebanlist") { require "$sourcedir/BanList.pl"; &DeleteBanList;}
if ($action eq "admin") { require "$sourcedir/Admin.pl"; &Admin;}
if ($action eq "viewtraffic") { require "$sourcedir/Admin.pl"; &ViewTraffic;}
if ($action eq "cleartraffic") { require "$sourcedir/Admin.pl"; &ClearTraffic;}
if ($action eq "viewnews") { require "$sourcedir/Admin.pl"; &ViewNews;}
if ($action eq "modifynews") { require "$sourcedir/Admin.pl"; &ModifyNews;}
if ($action eq "modifynews2") { require "$sourcedir/Admin.pl"; &ModifyNews2;}
if ($action eq "deletenews") { require "$sourcedir/Admin.pl"; &DeleteNews;}
if ($action eq "refresh") { require "$sourcedir/Refresh.pl"; &Refresh;}
if ($action eq "reminder") { require "$sourcedir/Login.pl"; &Reminder; }
if ($action eq "reminder2") { require "$sourcedir/Login.pl"; &Reminder2; }
if ($action eq "removecookie") { require "$sourcedir/Login.pl"; &RemoveCookie; }
if ($action eq "viewmessages") { require "$sourcedir/EditMessages.pl"; &ViewMessages;}
if ($action eq "modifymessage") { require "$sourcedir/EditMessages.pl"; &ModifyMessage;}
if ($action eq "modifymessage2") { require "$sourcedir/EditMessages.pl"; &ModifyMessage2;}
if ($action eq "deletemessage") { require "$sourcedir/EditMessages.pl"; &DeleteMessage;}
if ($action eq "viewtexts") { require "$sourcedir/EditTexts.pl"; &ViewTexts;}
if ($action eq "modifytext") { require "$sourcedir/EditTexts.pl"; &ModifyText;}
if ($action eq "modifytext2") { require "$sourcedir/EditTexts.pl"; &ModifyText2;}
if ($action eq "modifylist") { require "$sourcedir/EditTexts.pl"; &ModifyList;}
if ($action eq "modifylist2") { require "$sourcedir/EditTexts.pl"; &ModifyList2;}
if ($action eq "modifysettings") { require "$sourcedir/EditSettings.pl"; &ModifySettings;}
if ($action eq "modifysettings2") { require "$sourcedir/EditSettings.pl"; &ModifySettings2;}
if ($action eq "modifypermissions") { require "$sourcedir/EditPermissions.pl"; &ModifyPermissions;}
if ($action eq "modifypermissions2") { require "$sourcedir/EditPermissions.pl"; &ModifyPermissions2;}
if ($action eq "viewsmileys") { require "$sourcedir/EditSmileys.pl"; &ViewSmileys;}
if ($action eq "modifysmiley") { require "$sourcedir/EditSmileys.pl"; &ModifySmiley;}
if ($action eq "modifysmiley2") { require "$sourcedir/EditSmileys.pl"; &ModifySmiley2;}
if ($action eq "deletesmiley") { require "$sourcedir/EditSmileys.pl"; &DeleteSmiley;}
if ($action eq "movesmiley") { require "$sourcedir/EditSmileys.pl"; &MoveSmiley;}
if ($action eq "movesmiley2") { require "$sourcedir/EditSmileys.pl"; &MoveSmiley2;}
if ($action eq "viewaliases") { require "$sourcedir/EditAliases.pl"; &ViewAliases;}
if ($action eq "modifyalias") { require "$sourcedir/EditAliases.pl"; &ModifyAlias;}
if ($action eq "modifyalias2") { require "$sourcedir/EditAliases.pl"; &ModifyAlias2;}
if ($action eq "deletealias") { require "$sourcedir/EditAliases.pl"; &DeleteAlias;}
if ($action eq "domaintenance") { require "$sourcedir/Maintenance.pl"; &DoMaintenance;}
if ($action eq "domaintenance2") { require "$sourcedir/Maintenance.pl"; &DoMaintenance2;}
if ($action eq "endmaintenance") { require "$sourcedir/Maintenance.pl"; &EndMaintenance;}
require "$sourcedir/Login.pl";
&LoginFrame;
1;
