###############################################################################
# EditPermissions.pl                                                          #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub ModifyPermissions
{if (!hasPermission('admin_permissions'))
{fatal_error('nopermission');
}require "$language.descr";
my $output=<<"EOT";
<tr>
<th>
$text{permissions_permission}
</th>
<th>
$text{permissions_startingwithgroup}
</th>
</tr>
<form method=POST action="$cgi&action=modifypermissions2">
EOT
foreach my $key (sort keys %permission)
{my $description = getDescription('permissions_' . $key);
my $min = (exists($min_permission{$key})?$min_permission{$key}:-1);
my $options = "";
for (my $i=$min;$i<=3;$i++)
{my $selected= ($i==$permission{$key}?"selected":"");
$options .= "<option value=$i $selected>$group_names[$i+2]";
}$output .=<<"EOT";
<tr id="table2">
<td nowrap>$text{'permissions_' . $key}:$description</td>
<td width="100%"><select name="$key" style="width:100%">$options</select></td>
</tr>
EOT
}$output .= <<"EOT";
<tr id="table2">
<td colspan=2 align=center><input type=submit value="$text{permissions_submit}"></td>
</tr>
</form>
EOT
printheader("popup","",('{TITLE}' => $text{permissions_title},
'{ROWS}' => $output,
'{COMMENT}' => $text{permissions_comment}));
exitprog();
}sub ModifyPermissions2
{if (!hasPermission('admin_permissions'))
{fatal_error('nopermission');
}foreach my $key (keys %permission)
{if (exists($FORM{$key}))
{if ($FORM{$key}<-1)
{$FORM{$key} = -1;
}if (exists($min_permission{$key}) && $FORM{$key}<$min_permission{$key})
{$FORM{$key}=$min_permission{$key};
}if ($FORM{$key}>3)
{$FORM{$key} = 3;
}$permission{$key} = $FORM{$key};
}}writeSettingsFile();
print "Location: $cgi&action=admin\n\n";
exitprog();
}1;
