###############################################################################
# EditSmileys.pl                                                              #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub ViewSmileys
{if (!hasPermission('admin_smileys'))
{fatal_error('nopermission');
}my $output = <<"EOT";
<tr>
<th><b>$text{smileys_image}</b></th>
<th><b>$text{smileys_abbreviations}</b></th>
<th><b>$text{smileys_visible}</b></th>
<th>&nbsp;</th>
</tr>
EOT
my @smileys = split(/\|/,$smileys_defs);
for (my $i = 0; $i < @smileys; $i += 2)
{my $visible = $text{yes};
if ($smileys[$i] =~ /^#/)
{$visible = $text{no};
}$smileys[$i] =~ s/^#//;
trim($smileys[$i+1]);
$smileys[$i+1] =~ s/(\s)+/ /g;
ToHTML($smileys[$i+1]);
if (exists($image{$smileys[$i]}) && $smileys[$i+1] =~ /\S/)
{my($width,$height)=split(/,/,$image{$smileys[$i]});
my $tag="<img src=\"$imagesurl/$smileys[$i].gif\" width=\"$width\" height=\"$height\" border=0>";
$output .= <<"EOT";
<tr id="table2">
<td>$smileys[$i]&nbsp;$tag</td>
<td>$smileys[$i+1]</td>
<td align="center">$visible</td>
<td><a href="$cgi&action=modifysmiley&name=$smileys[$i]">$text{smileys_smiley_modify}</a>&nbsp;<a href="$cgi&action=movesmiley&name=$smileys[$i]">$text{smileys_smiley_move}</a></td>
</tr>
EOT
$image{$smileys[$i]}="";
}}foreach my $key (sort keys %image)
{if ($image{$key} ne "")
{my($width,$height)=split(/,/,$image{$key});
my $tag="<img src=\"$imagesurl/$key.gif\" width=\"$width\" height=\"$height\" border=0>";
$output .= <<"EOT";
<tr id="table2">
<td>$key&nbsp;$tag</td>
<td>&nbsp;</td>
<td align="center">$text{no}</td>
<td><a href="$cgi&action=modifysmiley&name=$key">$text{smileys_smiley_modify}</a></td>
</tr>
EOT
}}$output .= <<"EOT";
<tr id="table2">
<td colspan=4 align=center><a href="$cgi&action=modifysmiley">$text{smileys_createnew}</a></td>
</tr>
</table>
</td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{viewsmileys_title},
'{ROWS}' => $output,
'{COMMENT}' => $text{viewsmileys_comment}));
exitprog();
}sub ModifySmiley
{if (!hasPermission('admin_smileys'))
{fatal_error('nopermission');
}my($width,$height)=(1,1);
my $modify = 0;
my $visible = 1;
my $name = "<input type=text name=name size=20 maxlength=20 style=\"width=100%\">";
my $abbrev = "";
my $title = 'createsmiley_title';
my $delete = "";
if ($INFO{name} ne "")
{if (!exists($image{$INFO{name}}) || $image{$INFO{name}} eq "")
{fatal_error('unknownsmiley',$INFO{name});
}($width,$height)=split(/,/,$image{$INFO{name}});
$modify = 1;
$visible = "";
$name = "$INFO{name}<input type=hidden name=name value=\"$INFO{name}\">";
$title = 'modifysmiley_title';
if ($mandatory_images !~ /\Q|$INFO{name}|\E/)
{$delete="<input type=submit onClick=\"form.action.value='deletesmiley'\" value=\"$text{deletesmiley_submit}\">";
}my @smileys = split(/\|/,$smileys_defs);
for (my $i = 0; $i < @smileys; $i += 2)
{trim($smileys[$i+1]);
$smileys[$i+1] =~ s/(\s)+/ /g;
if ($smileys[$i] eq $INFO{name})
{$abbrev = $smileys[$i+1];
$visible = "checked";
last;
}if ($smileys[$i] eq "#$INFO{name}")
{$abbrev = $smileys[$i+1];
$visible = "";
last;
}}}ToHTML($abbrev);
printheader("popup","{ROWS}",('{TITLE}' => $text{$title},
'{COMMENT}' => $text{modifysmiley_comment}));
output(<<"EOT");
<tr><th>$text{$title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi">
<input type=hidden name=action value="modifysmiley2">
<input type=hidden name=modify value=$modify>
<tr>
<td><b>$text{smileys_image}:</b></td>
<td width=100%>$name</td>
</tr>
<tr>
<td><b>$text{smileys_width}:</b></td>
<td><input type=text name=width size=20 maxlength=50 value="$width" style="width=100%"></td>
</tr>
<tr>
<td><b>$text{smileys_height}:</b></td>
<td><input type=text name=height size=20 maxlength=50 value="$height" style="width=100%"></td>
</tr>
<tr>
<td><b>$text{smileys_abbreviations}:</b></td>
<td><input type=text name=abbreviations size=20 maxlength=50 value="$abbrev" style="width=100%"></td>
</tr>
<tr>
<td><b>$text{smileys_visible}:</b></td>
<td><input type=checkbox name=visible value=1 $visible></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit onClick="form.action.value='modifysmiley2'" value="$text{modifysmiley_submit}">
$delete
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{$title},
'{COMMENT}' => $text{modifysmiley_comment}));
exitprog();
}sub ModifySmiley2
{if (!hasPermission('admin_smileys'))
{fatal_error('nopermission');
}trim($FORM{name});
fatal_error('noimagegiven') if ($FORM{name} eq "");
fatal_error('illegalimage') if ($FORM{name} =~ /[^a-zA-z0-9\-\_]/);
if ($FORM{modify}!=0)
{if (!exists($image{$FORM{name}}) || $image{$FORM{name}} eq "")
{fatal_error('unknownsmiley',$FORM{name});
}}else
{if (exists($image{$FORM{name}}) && $image{$FORM{name}} ne "")
{fatal_error('smileyexists',$FORM{name});
}}$FORM{width}+=0;
$FORM{width}=1 if ($FORM{width}<1);
$FORM{height}+=0;
$FORM{height}=1 if ($FORM{height}<1);
$image{$FORM{name}}="$FORM{width},$FORM{height}";
trim($FORM{abbreviations});
$FORM{abbreviations} =~ s/(\s)+/ /g;
$FORM{abbreviations} =~ s/\|//g;
my @smileys = split(/\|/,$smileys_defs);
my $found = 0;
$smileys_defs = "";
for (my $i = 0; $i < @smileys; $i += 2)
{trim($smileys[$i+1]);
$smileys[$i+1] =~ s/(\s)+/ /g;
if ($smileys[$i] eq $FORM{name} || $smileys[$i] eq "#$FORM{name}")
{if ($FORM{abbreviations} ne "")
{$smileys_defs .= ($FORM{visible} == 0?"#":"") . "$FORM{name}|$FORM{abbreviations}|";
}$found = 1;
}else
{$smileys_defs .= "$smileys[$i]|$smileys[$i+1]|";
}}if ($found==0 && $FORM{abbreviations} ne "")
{$smileys_defs .= ($FORM{visible} == 0?"#":"") . "$FORM{name}|$FORM{abbreviations}|";
}$smileys_defs =~ s/\|$//g;
writeSettingsFile();
output("Location: $cgi&action=viewsmileys\n\n");
}sub DeleteSmiley
{if (!hasPermission('admin_smileys'))
{fatal_error('nopermission');
}trim($FORM{name});
fatal_error('noimagegiven') if ($FORM{name} eq "");
fatal_error('imagemandatory') if ($FORM{modify}==0 || $mandatory_images =~ /\Q|$FORM{name}|\E/);
fatal_error('unknownsmiley',$FORM{name}) if (!exists($image{$FORM{name}}) || $image{$FORM{name}} eq "");
my @smileys = split(/\|/,$smileys_defs);
$smileys_defs = "";
for (my $i = 0; $i < @smileys; $i += 2)
{trim($smileys[$i+1]);
$smileys[$i+1] =~ s/(\s)+/ /g;
if ($smileys[$i] ne $FORM{name} && $smileys[$i] ne "#$FORM{name}")
{$smileys_defs .= "$smileys[$i]|$smileys[$i+1]|";
}}$smileys_defs =~ s/\|$//g;
delete $image{$FORM{name}};
writeSettingsFile();
output("Location: $cgi&action=viewsmileys\n\n");
}sub MoveSmiley
{if (!hasPermission('admin_smileys'))
{fatal_error('nopermission');
}if (!exists($image{$INFO{name}}) || $image{$INFO{name}} eq "")
{fatal_error('unknownsmiley',$INFO{name});
}fatal_error('illegalimage') if ($INFO{name} =~ /[^a-zA-z0-9\-\_]/);
my $options = "<option value=\"\">$text{movesmiley_insertafter_first}";
my @smileys = split(/\|/,$smileys_defs);
my $found = 0;
for (my $i = 0; $i < @smileys; $i += 2)
{$smileys[$i] =~ s/^#//g;
if ($smileys[$i] eq $INFO{name})
{$found = 1;
}else
{$options .= "<option value=\"$smileys[$i]\">$smileys[$i]";
}}my $output = <<"EOT";
<tr><th>$text{movesmiley_title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi&action=movesmiley2">
<tr>
<td nowrap><b>$text{smileys_image}:</b></td>
<td width=100%>$INFO{name}<input type=hidden name=name value="$INFO{name}"></td>
</tr>
<tr>
<td nowrap><b>$text{movesmiley_insertafter}:</b></td>
<td><select name="insertafter" style="width=100%">$options</select></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit value="$text{movesmiley_submit}">
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{movesmiley_title},
'{ROWS}' => $output,
'{COMMENT}' => $text{movesmiley_comment}));
exitprog();
}sub MoveSmiley2
{if (!hasPermission('admin_smileys'))
{fatal_error('nopermission');
}trim($FORM{name});
fatal_error('noimagegiven') if ($FORM{name} eq "");
my @smileys = split(/\|/,$smileys_defs);
my $oldpos = -1;
my $insertpos = ($FORM{insertafter} eq ""?0:-1);
my @insert;
for (my $i = 0; $i < @smileys; $i += 2)
{if ($smileys[$i] eq $FORM{name} || $smileys[$i] eq "#$FORM{name}")
{$oldpos = $i;
@insert=($smileys[$i],$smileys[$i+1]);
}if ($smileys[$i] eq $FORM{insertafter} || $smileys[$i] eq "#$FORM{insertafter}")
{$insertpos = $i+2;
}}fatal_error('unknownsmiley',$FORM{name}) if ($oldpos == -1);
fatal_error('unknownsmiley',$FORM{insertafter}) if ($insertpos == -1);
if ($insertpos!=$oldpos && $insertpos!=$oldpos+2)
{splice(@smileys,$oldpos,2);
if ($insertpos>$oldpos)
{$insertpos -= 2;
}splice(@smileys,$insertpos,0,@insert);
}$smileys_defs = join('|',@smileys);
writeSettingsFile();
output("Location: $cgi&action=viewsmileys\n\n");
}1;
