###############################################################################
# EditTexts.pl                                                                #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub ViewTexts
{if (!hasPermission('admin_texts'))
{fatal_error('nopermission');
}require "$language.descr";
printheader("popup","{ROWS}",('{TITLE}' => $text{texts_title},
'{COMMENT}' => $text{texts_comment}));
output(<<"EOT");
<tr>
<th><b>$text{texts_name}</b></th>
<th><b>$text{texts_text}</b></th>
<th>&nbsp;</th>
</tr>
EOT
foreach my $entry (sort keys %text)
{ToHTML($text{$entry});
my $description=getDescription($entry);
output(<<"EOT");
<tr id="table2">
<td>$entry$description</td>
<td>$text{$entry}&nbsp;</td>
<td><a href="$cgi&action=modifytext&name=$entry">$text{texts_text_modify}</a></td>
</tr>
EOT
}output(<<"EOT");
</table>
</td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{texts_title},
'{COMMENT}' => $text{texts_comment}));
exitprog();
}sub ModifyText
{if (!hasPermission('admin_texts'))
{fatal_error('nopermission');
}if (!exists($text{$INFO{name}}))
{fatal_error('unknowntext',$INFO{name});
}my $text=$text{$INFO{name}};
$text =~ s/</&lt;/g;
$text =~ s/>/&gt;/g;
if ($INFO{num} >= 0)
{my @lines=split(/\n/,$message{$INFO{name}});
if ($INFO{num}>=@lines)
{$INFO{num} = (@lines>0?0:@lines-1);
}}printheader("popup","{ROWS}",('{TITLE}' => $text{modifytext_title},
'{COMMENT}' => $text{modifytext_comment}));
output(<<"EOT");
<tr><th>$text{modifytext_title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi&action=modifytext2">
<tr>
<td><b>$text{texts_name}:</b></td>
<td>$INFO{name}<input type=hidden name=name value="$INFO{name}"></td>
</tr>
<tr>
<td valign=top><b>$text{texts_text}:</b></td>
<td width=100%><textarea name="text" cols=35 rows=6 style="width:100%">$text</textarea></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit value="$text{modifytext_submit}">
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{modifytext_title},
'{COMMENT}' => $text{modifytext_comment}));
exitprog();
}sub ModifyText2
{if (!hasPermission('admin_texts'))
{fatal_error('nopermission');
}if (!exists($text{$FORM{name}}))
{fatal_error('unknowntext',$FORM{name});
}$text{$FORM{name}}=$FORM{text};
writeLanguageFile();
output("Location: $cgi&action=viewtexts\n\n");
}sub ModifyList
{$INFO{list}+=0;
if ($INFO{list}<0 || $INFO{list}>2)
{$INFO{list}=0;
}if (!hasPermission('admin_list' . $INFO{list}))
{fatal_error('nopermission');
}my @list;
my $title;
my $comment;
my $submit;
if ($INFO{list}==0)
{@list=@group_names;
$title='modifygroupnames_title';
$comment='modifygroupnames_comment';
$submit='modifygroupnames_submit';
}elsif ($INFO{list}==1)
{@list=@group_tags;
$title='modifygrouptags_title';
$comment='modifygrouptags_comment';
$submit='modifygrouptags_submit';
}elsif ($INFO{list}==2)
{@list=@months_names;
$title='modifymonthsnames_title';
$comment='modifymonthsnames_comment';
$submit='modifymonthsnames_submit';
}my $output=<<"EOT";
<tr><th>$text{$title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi&action=modifylist2">
<input type=hidden name=list value=$INFO{list}>
EOT
my $i=0;
foreach $entry(@list)
{ToHTML($entry);
$output .=<<"EOT";
<tr>
<td width="100%"><input type=text name=entry$i value="$entry" size=20 style="width:100%"></td>
</tr>
EOT
$i++;
}$output .= <<"EOT";
<tr>
<td align=center><input type=submit value="$text{$submit}"></td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{$title},
'{ROWS}' => $output,
'{COMMENT}' => $text{$comment}));
exitprog();
}sub ModifyList2
{$FORM{list}+=0;
if ($FORM{list}<0 || $FORM{list}>2)
{$FORM{list}=0;
}if (!hasPermission('admin_list' . $FORM{list}))
{fatal_error('nopermission');
}my @list;
if ($FORM{list}==0)
{@list=@group_names;
}elsif ($FORM{list}==1)
{@list=@group_tags;
}elsif ($FORM{list}==2)
{@list=@months_names;
}for(my $i=0;$i<@list;$i++)
{$list[$i]=$FORM{'entry' . $i};
}if ($FORM{list}==0)
{@group_names=@list;
}elsif ($FORM{list}==1)
{@group_tags=@list;
}elsif ($FORM{list}==2)
{@months_names=@list;
}writeLanguageFile();
print "Location: $cgi&action=admin\n\n";
exitprog();
}1;
