###############################################################################
# Login.pl                                                                    #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub Frames
{if ($pull_mode_only != 0)
{$FORM{pull}=1;
}my($username,$password,$pull)=split(/\|/,$COOKIE{$cookie_name});
if ($use_server_auth!=0)
{$username=$ENV{REMOTE_USER};
$password="";
}CheckName($username);
if ($username eq "")
{CheckName($FORM{username});
CheckPassword($FORM{password});
if ($FORM{password} ne "")
{$FORM{password}=crypt($FORM{password},$pwseed);
}$username=$FORM{username};
$password=$FORM{password};
}my $cookie="";
if ($FORM{cookie} != 0 && $password ne "")
{$cookie="Set-Cookie: $cookie_name=$username|$password|$FORM{pull}; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}elsif (exists $COOKIE{$cookie_name})
{$cookie="Set-Cookie: $cookie_name=; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}if ($use_usernames==0 && $password ne "")
{open(FILE, "$memberdir/memberlist.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my $found=0;
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if(eqi($userdata[0],$username))
{$found=1;
$username=$userdata[1];
}}if ($found==0)
{if (exists $COOKIE{$cookie_name})
{$cookie="Set-Cookie: $cookie_name=; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}fatal_error('unknownnickname',$username);
}}my %room=getroominfo($FORM{room});
if (!defined($room{name}) || RoomPermitted(%room)==0)
{$FORM{room} = $defaultroom;
}srand;
my $id=(split(/\./,rand()))[1];
my $time=time();
open(FILE, ">>$vardir/logins.txt");
lock(FILE);
print FILE "$id|$username|$password|$FORM{room}|$time\n";
unlock(FILE);
close(FILE);
$FORM{pull} = ($FORM{pull}==0?"0":"1");
$cgi = "$cgiurl/chat.pl?id=$id" . ($FORM{pull} != 0?"&pull=1":"");
print $cookie;
printheader("chat");
exitprog();
}sub LoginFrame
{my($username,$password,$pull)=split(/\|/,$COOKIE{$cookie_name});
if ($use_server_auth)
{$username=$ENV{REMOTE_USER};
$password="";
if (UserExists($username)==0)
{print "Location: $cgi&action=register\n\n";
exitprog();
}}CheckName($username);
open(ROOMS, "$roomdir/roomlist.txt");
readlock(ROOMS);
my @rooms=<ROOMS>;
unlock(ROOMS);
close(ROOMS);
my $roomlist="";
foreach my $room (@rooms)
{$room =~ s/[\n\r]//g;
my %roominfo = getroominfo($room);
if ($roominfo{closed} == 0)
{$selected="";
if (eqi($room,$defaultroom))
{$selected = " selected";
}$roomlist .= "<option value=\"$room\"$selected>$room\n";
}}open(FILE, "$vardir/online.txt");
readlock(FILE);
@entries = <FILE>;
unlock(FILE);
close(FILE);
my %users=();
foreach my $user (@entries)
{$user =~ s/[\n\r]//g;
my($name,$nick,$room,$ipcid) = split(/\|/,$user);
$users{$room} .= "|$nick";
}my $count=@entries;
my $list="";
my $div=0;
foreach my $room (sort keys(%users))
{my %roominfo = getroominfo($room);
if ($roominfo{closed} == 0)
{if ($div == 1)
{$list .= "</td></tr>";
}$list .= "<tr id=\"table1\"><td><b>$room</b></td></tr>\n";
$list .= "<tr id=\"table2\"><td>";
$div=1;
foreach my $nick (sort {lcase($a) cmp lcase($b)} split(/\|/,$users{$room}))
{if ($nick ne "")
{$list .= "&nbsp;$nick<br>\n";
}}$list .= "</ul>\n";
}}if ($div == 1)
{$list .= "</td></tr>";
}if ($list eq "")
{$list="<tr id=\"table2\"><td>$text{login_nouseronline}</td></tr>\n";
}my $news = "";
if($enable_news)
{open(FILE, "$vardir/news.txt");
&lock(FILE);
my @newsmessages = <FILE>;
&unlock(FILE);
close(FILE);
srand;
$news = "<b>$text{login_news}:</b> $newsmessages[int(rand(@newsmessages+0))]";
}my $output="";
if ($use_server_auth!=0)
{$output .=<<"EOT";
<tr>
<td><b>$text{profile_username}:</b></td>
<td width=100%>$username</td>
</tr>
EOT
}else
{my $username_text=($use_usernames==0?'profile_nickname':'profile_username');
my $wrongusername_text=($use_usernames==0?'login_nickname_wrong':'login_username_wrong');
my $input=($username eq ""?"<input type=text name=username size=20 style=\"width=100%\">"
:"$username<br><div id=\"smalltext\"><a href=\"$cgi&action=removecookie\">$text{$wrongusername_text}</a></div>");
$output .=<<"EOT";
<tr>
<td><b>$text{$username_text}:</b></td>
<td width=100%>$input</td>
</tr>
EOT
}if ($username eq "" && $use_server_auth==0)
{my $guests=($allow_guestlogin==0?"":" $text{login_password_guests}");
$output .=<<"EOT";
<tr>
<td><b>$text{profile_password}:</b>$guests</td>
<td><input type=password name=password size=20 style="width=100%"></td>
</tr>
EOT
}$output .=<<"EOT";
<tr>
<td><b>$text{profile_room}:</b></td>
<td><select name=room style="width=100%">
$roomlist
</select></td>
</tr>
EOT
$pull = ($pull==0?"":"checked");
if($pull_mode_only==0)
{$output .=<<"EOT";
<tr>
<td>&nbsp;</td>
<td><input type=checkbox name=pull value="1" $pull> $text{profile_pullmode}</td>
</tr>
EOT
}if ($use_server_auth==0)
{my $cookie = ($username eq ""?"":"checked");
my $cookie_text=($use_usernames==0?'login_cookie_savenickname':'login_cookie_saveusername');
$output .=<<"EOT";
<tr>
<td>&nbsp;</td>
<td><input type=checkbox name=cookie value="1" $cookie> $text{$cookie_text}</td>
</tr>
EOT
}$output .=<<"EOT";
<tr>
<td colspan=2 align=center><input type=submit value="$text{login_submit}"></td>
</tr>
EOT
printheader("login","",('{COUNT}' => $count,
'{USERS}' => $list,
'{NEWS}' => $news,
'{ROWS}' => $output));
exitprog();
}sub Reminder()
{fatal_error('reminder_disabled') if ($use_server_auth!=0);
my($username,$pull) = split(/\|/,$COOKIE{$cookie_name});
CheckName($username);
my $username_text=($use_usernames==0?'profile_nickname':'profile_username');
my $birthdate=getBirthdateInput();
my $output = <<"EOT";
<tr><th>$text{reminder_title}</th></tr>
<tr id="table2"><td><table width=100%>
<form name="form" method="POST" action="$cgi&action=reminder2">
<tr>
<td><b>$text{$username_text}:</b></td>
<td><input type=text name=username value="$username" size=30 style="width=100%" maxlength=20></td>
</tr>
<tr>
<td><b>$text{profile_birthdate}:</b></td>
<td>
$birthdate
</td>
</tr>
<tr>
<td colspan=2 align=center><input type=submit value="$text{reminder_submit}"></td>
</tr>
</table></td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{reminder_title},
'{ROWS}' => $output,
'{COMMENT}' => $text{reminder_comment}));
exitprog();
}sub Reminder2()
{fatal_error('reminder_disabled') if ($use_server_auth!=0);
CheckName($FORM{username});
if ($use_usernames==0)
{fatal_error('nonicknamegiven') if($FORM{username} eq "");
}else
{fatal_error('nousernamegiven') if($FORM{username} eq "");
}if ($FORM{day}<1 || $FORM{day}>31 || $FORM{month}<1 || $FORM{month}>12 || $FORM{year}<1000 || $FORM{year}>9999)
{fatal_error('illegalbirthdate');
}if ($use_usernames==0)
{open(FILE, "$memberdir/memberlist.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my $found=0;
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if(eqi($userdata[0],$FORM{username}))
{$found=1;
$FORM{username}=$userdata[1];
}}if ($found==0)
{if (exists $COOKIE{$cookie_name})
{$cookie="Set-Cookie: $cookie_name=; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}fatal_error('unknownnickname',$FORM{username});
}}%userinfo=getmemberinfo($FORM{username});
if (!defined($userinfo{name}))
{fatal_error('unknownusername',$FORM{username});
}$FORM{day}+=0;
$FORM{month}+=0;
$FORM{year}+=0;
if ($FORM{day}<10) {$FORM{day}="0" . $FORM{day};}
if ($FORM{month}<10) {$FORM{month}="0" . $FORM{month};}
if (crypt($FORM{day} . $FORM{month} . $FORM{year},$pwseed) ne $userinfo{birthday})
{fatal_error('wrongbirthdate');
}$password = crypt(time + rand(1000000000),$pwseed);
$password = substr($userinfo{password},2,6);
my $mail = sprintf($text{reminder_mail_body},$userinfo{nick},$userinfo{name},$password);
open(MAIL, "|$mailprog -t") || fatal_error('mailprogramerror');
print MAIL <<"EOT";
To: $userinfo{email}
From: $webmaster_email
Subject: $chatname: $text{reminder_mail_subject}
$mail
EOT
close(MAIL);
$userinfo{password} = crypt($password,$pwseed);
writememberinfo(%userinfo);
my $text = getMessage('reminder_success');
my $output = <<"EOT";
<tr><th>$text{reminder_title}</th></tr>
<tr id="table2"><td>
$text
</td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{reminder_title},
'{ROWS}' => $output,
'{COMMENT}' => ""));
exitprog();
}sub RemoveCookie
{if (exists $COOKIE{$cookie_name})
{print "Set-Cookie: $cookie_name=; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}print "Location: $cgi&action=loginframe\n\n";
exitprog();
}1;
