###############################################################################
# Maintenance.pl                                                              #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub Maintenance
{printheader("message","",('{TITLE}' => $text{maintenance_title},
'{MESSAGE}' => getMessage('error_maintenance'),
'{COMMENT}' => ''));
exitprog();
}sub DoMaintenance
{if (!hasPermission('admin_maintenance'))
{fatal_error('nopermission');
}my $text = getMessage('question_maintenance');
my $output = <<"EOT";
<tr>
<th><b>$text{maintenance_title}</b></th>
</tr>
<tr>
<td id="table2">
$text<br><br>
<div align=center><a href="$cgi&action=domaintenance2">$text{yes}</a> &nbsp; <a href="$cgi&action=admin">$text{no}</a></div>
</td>
</tr>
EOT
printheader("popup","",('{TITLE}' => $text{maintenance_title},
'{ROWS}' => $output,
'{COMMENT}' => ''));
exitprog();
}sub DoMaintenance2
{if (!hasPermission('admin_maintenance'))
{fatal_error('nopermission');
}$maintenance = 1;
writeSettingsFile();
open(FILE, "$vardir/online.txt");
readlock(FILE);
@entries = <FILE>;
unlock(FILE);
close(FILE);
foreach my $user (@entries)
{$user =~ s/[\n\r]//g;
my($name,$nick,$room,$ipcid) = split(/\|/,$user);
my %userinfo=getmemberinfo($name);
if ($userinfo{group}<$permission{admin_maintenance})
{my $text=CommandToText(command => 'quit',
name => $name,
text => getMessage('out_chat',$userinfo{nick},$chatname),
room => $room);
OutputCommand($text);
}}my $text = getMessage('info_maintenance_success');
my $output = <<"EOT";
<tr>
<th><b>$text{maintenance_title}</b></th>
</tr>
<tr>
<td id="table2">
$text
</td>
</tr>
EOT
printheader("popup","",('{TITLE}' => $text{title_maintenance},
'{ROWS}' => $output,
'{COMMENT}' => ''));
exitprog();
}sub EndMaintenance
{if (!hasPermission('admin_maintenance'))
{fatal_error('nopermission');
}$maintenance = 0;
writeSettingsFile();
print "Location: $cgi&action=admin\n\n";
exitprog();
}1;
