###############################################################################
# Profile.pl                                                                  #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub Register
{my $news = "";
if($enable_news)
{open(FILE, "$vardir/news.txt");
&lock(FILE);
my @newsmessages = <FILE>;
&unlock(FILE);
close(FILE);
srand;
$news = "<b>$text{login_news}\:</b> $newsmessages[int(rand(@newsmessages+0))]";
}my $smileys="";
if ($enable_smileys != 0)
{$smileys =<<"EOT";
<tr>
<td><b>$text{profile_smileys}:</b></td>
<td><input type=checkbox name=smileys value="1" checked></td>
</tr>
EOT
}my $username="";
if ($use_server_auth !=0)
{CheckName($ENV{REMOTE_USER});
$username =<<"EOT";
<tr>
<td><b>$text{profile_username}:</b></td>
<td>$ENV{REMOTE_USER}</td>
</tr>
EOT
}elsif ($use_usernames != 0)
{$username =<<"EOT";
<tr>
<td><b>$text{profile_username}*:</b></td>
<td width=100%><input type=text name=username size=30 style="width=100%" maxlength=20></td>
</tr>
EOT
}my $password="";
if ($use_server_auth==0)
{$password =<<"EOT";
<tr>
<td><b>$text{profile_password}*:</b></td>
<td><input type=password name=password size=30 style="width=100%" maxlength=10></td>
</tr>
<tr>
<td><b>$text{profile_password_again}*:</b></td>
<td><input type=password name=password2 size=30 style="width=100%" maxlength=10></td>
</tr>
EOT
}my $birthdate="";
if ($use_server_auth==0)
{$birthdate=getBirthdateInput();
$birthdate =<<"EOT";
<tr>
<td><b>$text{profile_birthdate}*:</b></td>
<td>
$birthdate
</td>
</tr>
EOT
}printheader("register","{ROWS}",'{NEWS}' => $news);
output(<<"EOT");
$username
<tr>
<td><b>$text{profile_nickname}*:</b></td>
<td width=100%><input type=text name=nickname size=30 style="width=100%" maxlength=50></td>
</tr>
$password
<tr>
<td><b>$text{profile_email}*:</b></td>
<td><input type=text name=email size=30 style="width=100%" maxlength=50></td>
</tr>
<tr>
<td><b>$text{profile_website_title}:</b></td>
<td><input type=text name=wwwtitle size=30 style="width=100%" maxlength=50></td>
</tr>
<tr>
<td><b>$text{profile_website_url}:</b></td>
<td><input type=text name=www size=30 style="width=100%" maxlength=50></td>
</tr>
$birthdate
<tr>
<td><b>$text{profile_email_private}:</b></td>
<td><input type=checkbox name=emailpublic value="1" checked></td>
</tr>
$smileys
<tr>
<td colspan=2 align=center><input type=submit value="$text{register_submit}"></td>
</tr>
EOT
printfooter("register","{ROWS}",'{NEWS}' => $news);
exitprog();
}sub Register2
{if ($use_server_auth!=0)
{$FORM{username}=$ENV{REMOTE_USER};
}CheckName($FORM{username});
CheckName($FORM{nickname});
CheckPassword($FORM{password});
fatal_error('nousernamegiven') if(($use_usernames!=0 || $FORM{modify}!=0) && $FORM{username} eq "");
fatal_error('nonicknamegiven') if($FORM{nickname} eq "");
fatal_error('passwordsnotequal') if($use_server_auth==0 && $FORM{password} ne "$FORM{password2}");
fatal_error('noemailgiven') if($FORM{email} eq "" && ($FORM{modify}!=1 || $FORM{group}!=-1));
fatal_error('illegalemail') if($FORM{email} !~ /^[0-9A-Za-z@\._\-]*$/);
ToHTML($FORM{www});
ToHTML($FORM{wwwtitle});
my %userinfo=();
my %olduserinfo=();
if ($FORM{modify}!=0)
{%userinfo=getmemberinfo($FORM{username});
%olduserinfo=%userinfo;
if (!defined($userinfo{name}))
{fatal_error('unknownusername',$FORM{username});
}if ($user{name} ne $userinfo{name} && (!hasPermission('profile_modify') || $user{group}<$userinfo{group}))
{fatal_error('profile_nopermission');
}if ($FORM{color} =~ /\S/)
{$userinfo{color}=makecolor($FORM{color});
if ($userinfo{color} eq "")
{fatal_error('unknowncolor',$FORM{color});
}}}else
{fatal_error('nopasswordgiven') if($use_server_auth==0 && $FORM{password} eq "");
if ($use_usernames==0)
{srand;
do
{$FORM{username}=substr(crypt(rand(),$pwseed),2,8);
} while (UserExists($FORM{username})!=0);
}else
{fatal_error('usernameexists',$FORM{username}) if(UserExists($FORM{username})!=0);
}}if ($use_server_auth==0)
{if ($FORM{modify}!=1 || $FORM{day}!=0 || $FORM{month}!=0 || $FORM{year}!=0)
{if ($FORM{day}<1 || $FORM{day}>31 || $FORM{month}<1 || $FORM{month}>12 || $FORM{year}<1000 || $FORM{year}>9999)
{fatal_error('illegalbirthdate');
}$FORM{day}+=0;
$FORM{month}+=0;
$FORM{year}+=0;
if ($FORM{day}<10) {$FORM{day}="0" . $FORM{day};}
if ($FORM{month}<10) {$FORM{month}="0" . $FORM{month};}
$userinfo{birthday} = crypt($FORM{day} . $FORM{month} . $FORM{year},$pwseed);
}}$userinfo{emailpublic} = ($FORM{emailpublic} == 1?0:1);
$userinfo{smileys} = ($FORM{smileys} == 1?1:0);
$userinfo{name}=$FORM{username};
$userinfo{nick}=$FORM{nickname};
if ($FORM{password} ne "")
{$userinfo{password}=crypt($FORM{password},$pwseed);
}if ($FORM{modify} == 1)
{if ($user{name} eq $userinfo{name})
{$userinfo{group} = $user{group};
}else
{$userinfo{group} = $FORM{group};
if ($userinfo{group} >= $user{group})
{$userinfo{group} = $user{group} - 1;
}}}else
{$userinfo{group} = 0;
}$userinfo{email} = $FORM{email};
$userinfo{www} = $FORM{www};
$userinfo{wwwtitle} = $FORM{wwwtitle};
if (addToMemberList($userinfo{name},$userinfo{nick}) == 0)
{fatal_error('nicknameexists',$userinfo{nick});
}writememberinfo(%userinfo);
my @onlineinfo=getonlineinfo($userinfo{name});
if (defined($onlineinfo[0]) && $olduserinfo{nick} ne $userinfo{nick})
{my $text=CommandToText(command => 'nick',
name => $userinfo{name},
text => getMessage('info_nickchanged',$olduserinfo{nick},$userinfo{nick}));
OutputCommand($text,$userinfo{name},$userinfo{room});
$onlineinfo[1]=$userinfo{nick};
writeonlineinfo(0,@onlineinfo);
}if (defined($onlineinfo[0]) && $olduserinfo{group} ne $userinfo{group})
{my $text=CommandToText(command => 'group',
name => $userinfo{name});
OutputCommand($text,$userinfo{name},$userinfo{room});
}if (defined($onlineinfo[0]) && $enable_smileys != 0 && $olduserinfo{smileys} != $userinfo{smileys})
{my $text=CommandToText(command => 'smileys',
nick => $userinfo{nick},
smileys => $userinfo{smileys});
OutputCommand($text,$userinfo{name});
}if (defined($onlineinfo[0]) && $olduserinfo{color} ne $userinfo{color})
{my $text=CommandToText(command => 'color',
nick => $userinfo{nick},
color => $userinfo{color});
OutputCommand($text,$userinfo{name});
}if ($FORM{modify} == 1)
{output("Location: $cgi&action=viewprofile&username=" . toFilename($userinfo{name}) . "\n\n");
}else
{printheader("register_success","{REGDATA}");
if ($use_usernames==0)
{output("<input type=hidden name=username value=\"$FORM{nickname}\">\n");
}else
{output("<input type=hidden name=username value=\"$FORM{username}\">\n");
}output("<input type=hidden name=password value=\"$FORM{password}\">\n");
printfooter("register_success","{REGDATA}");
}exitprog();
}sub ViewProfile
{$INFO{username} = fromFilename($INFO{username});
if (!defined($INFO{username}) || $INFO{username} eq "")
{$INFO{username} = $user{name};
}my %userinfo=getmemberinfo($INFO{username});
if (!defined($userinfo{name}))
{fatal_error('unknownusername',$INFO{username});
}@onlineinfo=getonlineinfo($INFO{username});
my $online='profile_state_offline';
if (defined($onlineinfo[0]))
{$online = ($userinfo{away} == 1?'profile_state_away':'profile_state_online');
}printheader("popup","{ROWS}",('{TITLE}' => "$userinfo{nick} ($text{$online})",
'{COMMENT}' => "$text{viewprofile_comment}"));
my $output = <<"EOT";
<tr><th>$userinfo{nick} ($text{$online})</th></tr>
<tr id="table2"><td><table width=100%>
<form name="form" method="POST" action="$cgi&action=send" target="dummy">
<input type=hidden name=text value="">
</form>
<script language="JavaScript">
function send(text)
{document.form.text.value=text;
document.form.submit();
}</script>
<tr>
<td><b>$text{profile_nickname}:<b></td>
<td>$userinfo{nick}&nbsp;</td>
</tr>
<tr>
<td><b>$text{profile_position}:</b></td>
<td>$group_names[$userinfo{group}+2]&nbsp;</td>
</tr>
<tr>
<td><b>$text{profile_color}:</b></td>
<td><font color="$userinfo{color}">$userinfo{color}</font>&nbsp;</td>
</tr>
EOT
if ($userinfo{emailpublic}==1 || hasPermission('profile_seeemail'))
{$output .= <<"EOT";
<tr>
<td><b>$text{profile_email}:</b></td>
<td><a href="mailto:$userinfo{email}">$userinfo{email}</a>&nbsp;</td>
</tr>
EOT
}if ($userinfo{www} ne "")
{if ($userinfo{www} !~ /^\w*\:\/\//)
{$userinfo{www} = "http://$userinfo{www}";
}my $wwwtitle = ($userinfo{wwwtitle} ne ""?$userinfo{wwwtitle}:$userinfo{www});
$output .= <<"EOT";
<tr>
<td><b>$text{profile_website}:</b></td>
<td><a href="$userinfo{www}" target="_blank">$wwwtitle</a>&nbsp;</td>
</tr>
EOT
}if (hasPermission('profile_seelastlogin'))
{my $lastlogin = ($userinfo{lastlogin} ne ""?toDate($userinfo{lastlogin}):"N/A");
$output .= <<"EOT";
<tr>
<td><b>$text{profile_lastlogin}:</b></td>
<td>$lastlogin&nbsp;</td>
</tr>
EOT
}if (defined($onlineinfo[0]))
{$output .= <<"EOT";
<tr>
<td><b>$text{profile_room}:</b></td>
<td>$userinfo{room}&nbsp;</td>
</tr>
EOT
}if (hasPermission('profile_seepullmode'))
{my $pull = ($userinfo{pull}==0?'no':'yes');
$output .= <<"EOT";
<tr>
<td><b>$text{profile_pullmode}:</b></td>
<td>$text{$pull}</td>
</tr>
EOT
}if (hasPermission('profile_seeip'))
{my $username = toFilename($userinfo{name});
$output .= <<"EOT";
<tr>
<td><b>$text{profile_browser}:</b></td>
<td>$userinfo{browser}&nbsp;</td>
</tr>
<tr>
<td><b>$text{profile_ip}:</b></td>
<td><a href="$cgi&action=traceroute&username=$username">$userinfo{ip}&nbsp;</td>
</tr>
EOT
if ($userinfo{forwardedfor} ne "")
{$output .= <<"EOT";
<tr>
<td><b>$text{profile_clientip}:</b></td>
<td>$userinfo{forwardedfor}&nbsp;</td>
</tr>
EOT
}if ($userinfo{host} ne "")
{$output .= <<"EOT";
<tr>
<td><b>$text{profile_hostname}:</b></td>
<td>$userinfo{host}&nbsp;</td>
</tr>
EOT
}}if (defined($onlineinfo[0]) && $user{name} ne $userinfo{name})
{$output .= <<"EOT";
<form name="msg" onSubmit="send('/msg $userinfo{nick} '+text.value);text.value='';return false;">
<tr>
<td><b>$text{profile_privatemessage}:</b></td>
<td>
<input type=text name=text size=13 maxlength=255>
<input type=submit value="$text{profile_privatemessage_submit}">
</td>
</tr>
</form>
EOT
}if ((hasPermission('profile_modify') && $user{group} > $userinfo{group}) || $user{name} eq $userinfo{name})
{my $username = toFilename($userinfo{name});
$output .= <<"EOT";
<tr>
<td colspan=2 align=center>
<a href=$cgi&action=modifyprofile&username=$username>$text{profile_editprofile}</a>
</td>
</tr>
EOT
}if (hasPermission('gag') && $userinfo{group} <= 0)
{$output .= <<"EOT";
<tr>
<td colspan=2 align=center><a href="javascript:send('/gag $userinfo{nick}')">$text{profile_gag}</a></td>
</tr>
EOT
}if (hasPermission('kick') && $userinfo{group} <= 0)
{$output .= <<"EOT";
<tr>
<td colspan=2 align=center><a href="javascript:send('/kick $userinfo{nick}')">$text{profile_kick}</a></td>
</tr>
EOT
}if (hasPermission('admin_banlist') && $userinfo{group} <= 0)
{$output .= <<"EOT";
<tr>
<td colspan=2 align=center><a href="javascript:addToBanList('$userinfo{host}','$userinfo{ip}','$userinfo{forwardedfor}')">$text{profile_ban}</a></td>
</tr>
EOT
}$output .= <<"EOT";
</table></td></tr>
EOT
output($output);
printfooter("popup","{ROWS}",('{TITLE}' => "$userinfo{nick} ($text{$online})",
'{COMMENT}' => "$text{viewprofile_comment}"));
exitprog();
}sub ModifyProfile
{$INFO{username}=fromFilename($INFO{username});
if (!defined($INFO{username}) || $INFO{username} eq "")
{$INFO{username}=$user{name};
}my %userinfo=getmemberinfo($INFO{username});
if (!defined($userinfo{name}))
{fatal_error('unknownusername',$INFO{username});
}if ($user{name} ne $userinfo{name} && (!hasPermission('profile_modify') || $user{group}<$userinfo{group}))
{fatal_error('profile_nopermission');
}my $delete = "<input type=submit onClick=\"form.action.value='deleteuser'\" value=\"$text{deleteprofile_submit}\">";
if ($userinfo{group} == 3 || $userinfo{group} == -1)
{$delete = "";
}my $emailpublicchecked = ($userinfo{emailpublic}==0?" checked":"");
my $smileyschecked = ($userinfo{smileys}==1?" checked":"");
if ($user{name} eq $userinfo{name} || $userinfo{group}==-1)
{$status = "<input type=hidden name=group value=\"$userinfo{group}\">$group_names[$userinfo{group}+2]\n";
}else
{$status = "<select name=group>\n";
for (my $i=-2; $i < $user{group}; $i++)
{if ($i != -1)
{my $selected = ($i == $userinfo{group}?" selected":"");
$status .= "<option value=\"$i\"$selected>$group_names[$i+2]\n";
}}$status .= "</select>\n";
}my $password="";
my $birthday="";
if ($use_server_auth==0 && $userinfo{group} >= 0)
{$password=<<"EOT";
<tr>
<td><b>$text{profile_password}:</b></td>
<td><input type=password name=password size=10 style="width:100%" maxlength=10></td>
</tr>
<tr>
<td><b>$text{profile_password_again}:</b></td>
<td><input type=password name=password2 size=10 style="width:100%" maxlength=10></td>
</tr>
EOT
$birthdate=getBirthdateInput();
$birthdate=<<"EOT";
<tr>
<td><b>$text{profile_birthdate}:</b></td>
<td>
$birthdate
</td>
</tr>
EOT
}my $colors="";
foreach my $color (@palette)
{$colors .= "<td width=12 bgcolor=\"$color\"><a href=\"javascript:selcol('$color')\"><img src=$imagesurl/blank.gif width=12 height=12 border=0 alt=\"$color\"></a></td>\n";
}my $smileys="";
if ($enable_smileys != 0)
{$smileys=<<"EOT";
<tr>
<td><b>$text{profile_smileys}:</b></td>
<td><input type=checkbox name=smileys value="1" $smileyschecked></td>
</tr>
EOT
}my $username =<<"EOT";
<tr>
<td><b>$text{profile_username}:</b></td>
<td><input type=hidden name=username value="$userinfo{name}">$userinfo{name}</td>
</tr>
EOT
if ($use_usernames == 0)
{$username = "<input type=hidden name=username value=\"$userinfo{name}\">";
}printheader("popup","{ROWS}",('{TITLE}' => "$userinfo{nick}",
'{COMMENT}' => "$text{modifyprofile_comment}"));
output(<<"EOT");
<tr><th>$userinfo{nick}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST name="form" action="$cgi">
<input type=hidden name=action value="modifyprofile2">
<input type=hidden name=modify value="1">
$username
<tr>
<td><b>$text{profile_nickname}:</b></td>
<td width="100%"><input type=text name=nickname size=10 style="width:100%" maxlength=50 value="$userinfo{nick}"></td>
</tr>
$password
<tr>
<td><b>$text{profile_email}:</b></td>
<td><input type=text name=email size=10 style="width:100%" maxlength=50 value="$userinfo{email}"></td>
</tr>
<tr>
<td><b>$text{profile_website_title}:</b></td>
<td><input type=text name=wwwtitle size=10 style="width=100%" maxlength=50 value="$userinfo{wwwtitle}"></td>
</tr>
<tr>
<td><b>$text{profile_website_url}:</b></td>
<td><input type=text name=www size=10 style="width=100%" maxlength=50 value="$userinfo{www}"></td>
</tr>
$birthdate
<tr>
<td><b>$text{profile_email_private}:</b></td>
<td><input type=checkbox name=emailpublic value="1" $emailpublicchecked></td>
</tr>
$smileys
<tr>
<td><b>$text{profile_position}:</b></td>
<td>$status</td>
</tr>
<tr>
<td><b>$text{profile_color}:</b></td>
<td><input type=text name=color size=10 style="width:100%" maxlength=10 onChange="selcol(value)"></td>
</tr>
<tr>
<td>&nbsp;&nbsp;<b>$text{profile_color_red}:</b></td>
<td>&nbsp;&nbsp;<input type=text name=red size=10 maxlength=3 onChange="combineColors()"></td>
</tr>
<tr>
<td>&nbsp;&nbsp;<b>$text{profile_color_green}:</b></td>
<td>&nbsp;&nbsp;<input type=text name=green size=10 maxlength=3 onChange="combineColors()"></td>
</tr>
<tr>
<td>&nbsp;&nbsp;<b>$text{profile_color_blue}:</b></td>
<td>&nbsp;&nbsp;<input type=text name=blue size=10 maxlength=3 onChange="combineColors()"></td>
</tr>
<script>selcol("$userinfo{color}")</script>
<tr>
<td colspan=2>
<table align=center border=0 cellspacing=0 cellpadding=0><tr>
$colors
</tr></table>
</td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit onClick="form.action.value='register2'" value="$text{modifyprofile_submit}">
$delete
</td>
</tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => "$userinfo{nick}",
'{COMMENT}' => "$text{modifyprofile_comment}"));
exitprog();
}sub DeleteUser
{fatal_error('nousernamegiven') if(!defined($FORM{username}));
%userinfo=getmemberinfo($FORM{username});
if (!defined($userinfo{name}))
{fatal_error('unknownusername',$FORM{username});
}if ($user{name} ne $userinfo{name} && (!hasPermission('profile_modify') || $user{group}<$userinfo{group}))
{fatal_error('deleteuser_nopermission');
}if ($userinfo{group}==3)
{fatal_error('deleteuser_chatmaster');
}if ($userinfo{group}==-1)
{fatal_error('deleteuser_guest');
}my @onlineinfo=getonlineinfo($userinfo{name});
if (defined($onlineinfo[0]))
{$text=CommandToText(command => 'quit',
name => $userinfo{name},
text => getMessage('out_chat',$userinfo{nick},$chatname),
room => $userinfo{room},
id => $onlineinfo[4]);
OutputCommand($text);
}addToMemberList($userinfo{name});
my $filename=toFilename($userinfo{name});
unlink("$memberdir/$filename.dat");
printheader("deleted");
exitprog();
}sub TraceRoute {
if (!hasPermission('profile_seeip'))
{fatal_error('nopermission');
}$INFO{username}=fromFilename($INFO{username});
fatal_error('nousernamegiven') if(!defined($INFO{username}));
my %userinfo=getmemberinfo($INFO{username});
if (!defined($userinfo{name}))
{fatal_error('unknownusername',$INFO{username});
}select (STDOUT);
$| = 1;
printheader("traceroute","{ROWS}",'{TITLE}' => sprintf($text{traceroute_title},"<a href=\"$cgi&action=viewprofile&username=" . toFilename($userinfo{name}) . "\" id=\"stdlink\">$userinfo{nick}</a>"));
my $comment=sprintf($text{traceroute_comment},$userinfo{ip});
output(<<"EOT");
<span id="headertext">$comment<br><br>
<pre>
EOT
open(TRACEROUTE,"traceroute $userinfo{ip}|");
while (<TRACEROUTE>) {
output($_);
}close(TRACEROUTE);
output("</pre></span>\n");
printfooter("traceroute","{ROWS}",sprintf($text{traceroute_title},"<a href=\"$cgi&action=viewprofile&username=" . toFilename($userinfo{name}) . "\" id=\"stdlink\">$userinfo{nick}</a>"));
exitprog();
}1;
